
-- [turtlesort.com, 2012]

-- Convenience table for defining/playing audio sources.


local audio = {}

audio.enabled = true

-- defines audio sources to be used in the game
-- and some convenience methods for playing those
-- audio sources
local sound = {}

function audio.add(path,playback,id)
	sound[id] = love.audio.newSource(path,playback)
	return sound[id]
end

function audio.play(id)
	if audio.enabled then
		sound[id]:stop()
		sound[id]:setLooping(false)
		sound[id]:play()
	end
end

function audio.loop(id)
	if audio.enabled then
		sound[id]:setLooping(true)
		sound[id]:play()
	end
end

function audio.stop(id)
	if audio.enabled then
		sound[id]:stop()
	end
end

function audio.stopAll()
	if audio.enabled then
		for _, v in pairs(sound) do
			v:stop()
		end
	end
end

function audio.get(id)
	return sound[id]
end

return audio