
-- [turtlesort.com, 2012]

-- Convenience functions for game entity creation and updating

local entity = {}

-- Instantiates a generic entity and returns it
function entity.new(x,y,angle,speed)
	local e = {}

	e.x = x or 0
	e.y = y or 0
	e.angle = angle or 0
	e.speed = speed or 0
	
	return e
end

-- Updates the specified game entity providing they have
-- the keys 'x','y','speed', and 'angle' defined.
function entity.update(entity,dt)
		local cos = math.cos(entity.angle)
		local sin = -math.sin(entity.angle)
		local xSpeed = entity.speed * cos
		local ySpeed = entity.speed * sin
		
		entity.x = entity.x + xSpeed*dt
		entity.y = entity.y + ySpeed*dt
end

return entity