
-- [Ice Project 2012, turtlesort.com]

-- In charge of drawing the correct sprite
-- from the character spritesheet on the screen
-- based on the state of the player. Additionally,
-- this script is used to draw NPCs.

local sprite = {}

-- sprite sheet actual dimension is 240x240
-- but we need to make it a power of 2 for older graphics cards
local dimension = 256;

sprite.image = g.newImage('turtlesort_iceproject_sprite_48.png')

sprite.quadcache = {}
sprite.quadcache['down'] = g.newQuad(0,0,48,48,dimension,dimension)
sprite.quadcache['down1'] = g.newQuad(48,0,48,48,dimension,dimension)
sprite.quadcache['down2'] = g.newQuad(96,0,48,48,dimension,dimension)
sprite.quadcache['up'] = g.newQuad(0,48,48,48,dimension,dimension)
sprite.quadcache['up1'] = g.newQuad(48,48,48,48,dimension,dimension)
sprite.quadcache['up2'] = g.newQuad(96,48,48,48,dimension,dimension)
sprite.quadcache['right'] = g.newQuad(0,96,48,48,dimension,dimension)
sprite.quadcache['right1'] = g.newQuad(48,96,48,48,dimension,dimension)
sprite.quadcache['right2'] = g.newQuad(96,96,48,48,dimension,dimension)
sprite.quadcache['left'] = g.newQuad(0,144,48,48,dimension,dimension)
sprite.quadcache['left1'] = g.newQuad(48,144,48,48,dimension,dimension)
sprite.quadcache['left2'] = g.newQuad(96,144,48,48,dimension,dimension)
sprite.quadcache['falling'] = g.newQuad(48*4,0,48,48,dimension,dimension)
sprite.quadcache['onground'] = g.newQuad(48*4,48*2,48,48,dimension,dimension)

sprite.quadcache['childofwinter'] = g.newQuad(48*4,48*4,48,48,dimension,dimension)

function sprite.draw(x,y,direction,tilex,tiley,isStationary)

	if isStationary or direction == 'falling' or direction == 'onground' then
		g.drawq(
			sprite.image,
			sprite.quadcache[direction],
			x,
			y - 12
		)
	else
		g.drawq(
			sprite.image,
			sprite.quadcache[direction .. ((tilex + tiley)%2+1)],
			x,
			y - 12
		)		
	end

end

return sprite