
-- [Ice Project 2012, turtlesort.com]

-- For displaying the credits after player
-- finishes game!

-- Game (Programming, Music, Art, Story) by
-- Kevin Sacro (turtlesort.com)

-- Powered by
-- LVE (love2d.org)

-- "Press Start 2P" font by 
-- Cody "CodeMan38" Boisclair  (zone38.net)

-- Sound Effects created using
-- bfxr (www.bfxr.net)

-- Thanks for playing!

local scene = {}
local credits = {
	{'Gioco', 'Kevin Sacro', 'turtlesort.com'},
	{'Arte', 'Kevin Sacro', 'turtlesort.com'},
	{'Musica', 'Kevin Sacro', 'turtlesort.com'},
	{'Font "Press Start 2P"', 'Cody "CodeMan38" Boisclair', 'zone38.net'},
	{'Suoni generati usando', 'bfxr', 'www.bfxr.net'},
	{'Powered by', 'LVE', 'love2d.org'},
	{'','Grazie per aver giocato!',''}
}
local credit_duration = 5.0 -- seconds per credit
local fade_duration = 0.75
local x_align = 200
local y_align = 220

local credit_timer = 0
local credit_index = 1
local loaded = false

function scene.load()

	if not loaded then
		loaded = true

		if not game.snow.on then
			game.snow.clear()
			game.snow.fillscreen()
			game.snow.on = true
		end

		game.audio.stopAll()
		game.audio.play('theme')

		g.setBackgroundColor(0,0,0)
	end
	
end

function scene.update(dt)
	game.snow.update(dt)
	
	credit_timer = credit_timer + dt
	if credit_timer > credit_duration then
		credit_timer = 0
		credit_index = credit_index + 1
		
		if credit_index > #credits then
			credit_index = #credits
		end
		
	end
end

function scene.draw()

	game.snow.draw()

	local c1 = credits[credit_index]
	local alpha = math.floor(255 * ((credit_timer - (credit_duration - fade_duration)) / fade_duration))
	
	--if alpha > 255 then alpha = 255 end
	if alpha < 0 or (credit_index == #credits) then alpha = 0 end
	
	-- current credit fades out
	g.setColor(255,255,255,255-alpha)
	g.setFont(game.font.get(22))
	g.printf(c1[1], 15, y_align, g.getWidth(), 'center')

	g.setFont(game.font.get(30))
	g.printf(c1[2], 15, y_align + 50, g.getWidth(), 'center')
	
	-- next credit fades in 
	--
	if alpha > 0 and not (credit_index == #credits) then		
		local c2 = credits[credit_index+1]
		g.setColor(255,255,255,alpha)
		g.setFont(game.font.get(22))
		g.printf(c2[1], 15, y_align, g.getWidth(), 'center')
	
		g.setFont(game.font.get(30))
		g.printf(c2[2], 15, y_align + 50, g.getWidth(), 'center')
	end
	--]]
	-- g.setFont(game.font.get(15))
	-- g.printf(c[3], 0, y_align + 100, g.getWidth(), 'center')

end

function scene.keypressed(key,unicode)

	if key == 'escape' then
		love.event.push('q')
	end

end

return scene