
-- [Ice Project 2012, turtlesort.com]

-- This scene depicts the player falling down
-- the hole.

local scene = {}

function scene.init()

	scene.player = {}
	scene.player.y = -50
	scene.player.status = 'falling'
	scene.tileset = {}
	
	scene.dialog = require 'lib/dialog'
	scene.dialog.font = game.font.get(16)
	
end

function scene.load()

	g.setBackgroundColor(51,51,51) -- matches the tileset's bg	
	
	local mainScene = game.getScene('main')
	scene.player.sprite = mainScene.player.sprite
	scene.tileset.tilewidth = mainScene.tileset.tilewidth
	mainScene.alpha = 0
	
end

function scene.update(dt)
	
	if scene.player.y < scene.tileset.tilewidth * 5 then
		scene.player.y = scene.player.y + dt * 350
	elseif scene.player.y > scene.tileset.tilewidth * 5 then
	
		game.audio.stopAll()
		game.audio.play('hit')
	
		scene.player.y = scene.tileset.tilewidth * 5
		scene.player.status = 'onground'
		
		scene.dialog.endevent = function ()
			game.snow.on = false
			local fader = game.getScene('fader')
			fader.fadeOutTime = 0
			fader.fadeInTime = 0
			fader.setTarget('main')
			game.setCurrentScene('fader')
		end
		
		scene.dialog.display(game.text.hittheground,1)

	end
	
	scene.dialog.update(dt)

end

function scene.draw()

	g.setColor(255,255,255)
	
	scene.player.sprite.draw(
		scene.tileset.tilewidth * 7,
		scene.player.y,
		scene.player.status
	)
	
	scene.dialog.draw()
	
end


function scene.keypressed(key,unicode)
	scene.dialog.keypressed(key,unicode)
	
	if key == 'escape' then
		love.event.push('q')
	end
	
end

return scene