
-- [Ice Project 2012, turtlesort.com]

-- First scene in game displayed to player. This
-- is where the 'turtlesort presents' text is displayed.
-- Immediately transitions to main screen.

local scene = {}
local font = game.font.get(15)
local bigfont = game.font.get(24)
local text = game.text.gamepresents
local title = game.text.gametitle
local caption = game.text.gametitlecaption
local running = true
local timer = 0
local duration = 3.0 -- number of seconds this scene lasts until transitioning to main screen
local state = 0
local mainScene

local captionfade = 0
local captionfadestate = 'in'

function scene.load()
	
	if state < 2 then     -- first load displays text
		state = state + 1 -- all other consecutive loads will display menu
	end
	
	timer = 0
	running = true
	
	if state == 2 then
		game.audio.loop('theme')
		mainScene = game.getScene('main')
		mainScene.load()
	end
	
end

function scene.update(dt)

	if state == 1 then
		timer = timer + dt

		-- once timer hits specified duration transition to main screen
		if timer >= duration and running then
			running = false
			-- game.getScene('fader').setTarget('main')
			game.getScene('fader').setTarget('intro')
			game.setCurrentScene('fader')
		end
	elseif state == 2 then
		mainScene.update(dt)
		
		if captionfadestate == 'in' then
			captionfade = captionfade + dt*250
		else
			captionfade = captionfade - dt*250
		end
		
		if captionfade > 355 then
			captionfade = 255
			captionfadestate = 'out'
		elseif captionfade < 0 then
			captionfade = 0
			captionfadestate = 'in'
		end
		
	end

end

function scene.draw()
	-- draw the text at the center of screen
	g.setColor(255,255,255)
	
	if state == 1 then
		g.setFont(font)
		g.print(text,love.graphics.getWidth()/2 - font:getWidth(text)/2 ,love.graphics.getHeight()/2 - font:getHeight(text)/2)
	
	elseif state == 2 then
		
		mainScene.draw()
		
		g.setColor(51,51,51)
		g.setFont(bigfont)
		g.print(title, love.graphics.getWidth()/2 - bigfont:getWidth(title)/2 , love.graphics.getHeight()/2 - bigfont:getHeight(title)/2 + 170)
		
		if captionfade > 255 then
			g.setColor(51,51,51,255)
		else
			g.setColor(51,51,51,captionfade)
		end
		
		g.setFont(font)
		g.print(caption, love.graphics.getWidth()/2 - font:getWidth(caption)/2 , love.graphics.getHeight()/2 - font:getHeight(caption)/2 + 210)

	end
	
end

-- player can speed up transition by pressing any key
function scene.keypressed(key,unicode)

	if state == 1 then
		timer = duration
	elseif state == 2 and (key == 'return' or key == ' ') then
		game.setCurrentScene('main')
	end
	
end

return scene